package com.xiaoyue.tinkers_ingenuity;

package ..deTemp.1741077868030;

import com.mojang.logging.LogUtils;
import com.xiaoyue.tinkers_ingenuity.event.PLivingEvent;
import com.xiaoyue.tinkers_ingenuity.register.BaseBlocks;
import com.xiaoyue.tinkers_ingenuity.register.BaseItems;
import com.xiaoyue.tinkers_ingenuity.register.Effects;
import com.xiaoyue.tinkers_ingenuity.register.EntityTypes;
import com.xiaoyue.tinkers_ingenuity.register.Fluids;
import com.xiaoyue.tinkers_ingenuity.register.LootModifier;
import com.xiaoyue.tinkers_ingenuity.register.Modifiers;
import java.util.stream.Collectors;
import net.minecraft.client.renderer.entity.EntityRendererProvider;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.item.Item;
import net.minecraft.world.level.block.Blocks;
import net.minecraftforge.client.event.EntityRenderersEvent;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.server.ServerStartingEvent;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.InterModComms;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.event.lifecycle.InterModEnqueueEvent;
import net.minecraftforge.fml.event.lifecycle.InterModProcessEvent;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import org.slf4j.Logger;
import slimeknights.tconstruct.library.client.model.TinkerItemProperties;

@Mod("tinkers_ingenuity")
public class tinkers_ingenuity {
  private static final Logger LOGGER = LogUtils.getLogger();
  
  public static final String MOD_ID = "tinkers_ingenuity";
  
  public tinkers_ingenuity() {
    IEventBus eventBus = FMLJavaModLoadingContext.get().getModEventBus();
    MinecraftForge.EVENT_BUS.register(new PLivingEvent());
    BaseBlocks.BLOCKS.register(eventBus);
    BaseItems.ITEMS.register(eventBus);
    EntityTypes.ENTITY_TYPES.register(eventBus);
    Effects.EFFECT.register(eventBus);
    Modifiers.MODIFIERS.register(eventBus);
    Fluids.FLUIDS.register(eventBus);
    LootModifier.REGISTRY.register(eventBus);
    eventBus.addListener(this::render);
    eventBus.addListener(this::setup);
    eventBus.addListener(this::enqueueIMC);
    eventBus.addListener(this::processIMC);
    eventBus.addListener(this::clientCommon);
    MinecraftForge.EVENT_BUS.register(this);
  }
  
  private void clientCommon(FMLClientSetupEvent event) {
    event.enqueueWork(() -> {
          TinkerItemProperties.registerToolProperties((Item)BaseItems.BATTLEAXE.get());
          TinkerItemProperties.registerToolProperties((Item)BaseItems.BIGSICKLE.get());
          TinkerItemProperties.registerToolProperties((Item)BaseItems.BOWIEKNIFE.get());
          TinkerItemProperties.registerToolProperties((Item)BaseItems.BATTLESIGN.get());
          TinkerItemProperties.registerToolProperties((Item)BaseItems.GREATSWORD.get());
          TinkerItemProperties.registerToolProperties((Item)BaseItems.LOGRAZOR.get());
          TinkerItemProperties.registerToolProperties((Item)BaseItems.HAMMER.get());
        });
  }
  
  private void render(EntityRenderersEvent.RegisterRenderers event) {
    event.registerEntityRenderer((EntityType)EntityTypes.DIAMOND_ARROW_ENTITY.get(), com.xiaoyue.tinkers_ingenuity.entity.Render.RDiamondArrow::new);
    event.registerEntityRenderer((EntityType)EntityTypes.IRON_ARROW_ENTITY.get(), com.xiaoyue.tinkers_ingenuity.entity.Render.RIronArrow::new);
    event.registerEntityRenderer((EntityType)EntityTypes.LIGHTNING_ARROW_ENTITY.get(), com.xiaoyue.tinkers_ingenuity.entity.Render.RLightningArrow::new);
    event.registerEntityRenderer((EntityType)EntityTypes.OCEAN_ARROW_ENTITY.get(), com.xiaoyue.tinkers_ingenuity.entity.Render.ROceanArrow::new);
  }
  
  private void setup(FMLCommonSetupEvent event) {
    LOGGER.info("HELLO FROM PREINIT");
    LOGGER.info("DIRT BLOCK >> {}", Blocks.f_50493_.getRegistryName());
  }
  
  private void enqueueIMC(InterModEnqueueEvent event) {
    InterModComms.sendTo("examplemod", "hello_world", () -> {
          LOGGER.info("Hello world from the MDK");
          return "Hello world";
        });
  }
  
  private void processIMC(InterModProcessEvent event) {
    LOGGER.info("Got IMC {}", event.getIMCStream()
        .map(m -> m.messageSupplier().get())
        .collect(Collectors.toList()));
  }
  
  @SubscribeEvent
  public void onServerStarting(ServerStartingEvent event) {
    LOGGER.info("HELLO from server starting");
  }
}
